<html>
<head>
	<title>Çoklu Sır Paylaşım Şeması</title>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta http-equiv="X-UA-Compatible" content="IE=edge" />
	<meta name="viewport" content="width=device-width, initial-scale=1">

	<script type="text/javascript" src="jquery-1.10.2.js"></script>
	<!--<link rel="stylesheet" type="text/css" href="bootstrap-3.3.7-dist/css/bootstrap.css">-->
	<!--<script type="text/javascript" src="bootstrap-3.3.7-dist/js/bootstrap.js"></script>-->
	
	<style>
		#divMap table, #divMap  th, #divMap  td {
			border: 1px solid black;
		}
		#divMap td {
		  width: 100px;
		  text-align: center;
		}
		table {
			border-collapse: collapse;
		}
		#divEncode {
		  width: auto;
		  height: auto;
		  display: block;
		  justify-content: center;
		}
		.greenBackground {
		  background-color: green;
		}
		.floatingDiv {
		  float: left;
		  width: 100%;
		  height: auto;
		  display: flex;
		  justify-content: center;
		  align-items: flex-end;
		}
    </style>
	
	<script type="text/javascript" src="calculationlib/matrixlib.js"></script>
	<script type="text/javascript" src="calculationlib/ecclib.js"></script>
	<script type="text/javascript" src="calculationlib/polynomial.js"></script>
	<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
	<!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
	<script type="text/x-mathjax-config">
		MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
		MathJax.Localization.setLocale("tr");
	</script>
	<script>
		
		rowCount = 1;
		var AddFormula = function(container, name, tex) {
			var containerSelector = $('#' + container);
			if ($('#' + name).length == 0)
				containerSelector.append("<div id='" + name + "' style='text-align:center; visibility: visible; padding:10;'>");
			else $('#' + name).html("");

			$('#' + name).append($('<script type="math/tex">').text("\\displaystyle{"+tex+"}"));
			MathJax.Hub.Queue(
				//function () { $('#' + name).css('visibility','hidden')
				["Typeset",MathJax.Hub]
				//,function () { $('#' + name).css('visibility','visible') }
			);
		}
		var AddAccessSetInput = function(tableId, count, rowId){
			var text = "<tr>";
			for (var i = 1; i < count+1; i++){
				text += "<td> <input type='checkbox' row='" + rowId + "' col='" + i + "' /> </td>"
			}
			text += "</tr>";
			$('#' + tableId + ' tr:last').after(text);
		}
		var CreateInput = function(inputCount, q) {

			var text = "<table>";

			text += "<tr>";
			for (var i = 1; i < inputCount+1; i++)
				text += "<td align='center'>" + i + "</td>";
			text += "</tr>";

			text += "<tr>";
			for (var i = 1; i < inputCount+1; i++)
				text += "<td><input type='text' style='text-align:center;' maxlength='4' size='4' num=" + i + " id='txtInpt" + i + "' /></td>";
			text += "</tr>";

			text += "</table>";
			return text;
		}	
		var ReadMatrix = function(text) {
				
			var data = [];
			text = text.replace( /\s\s+/g, ' ' );
			var lines = text.split(/\r|\n/);
			for (var i = 0; i < lines.length; i++) {
				var lineData = [];
				var cells = lines[i].split(' ');
				for (var j = 0; j < cells.length; j++) {
					if(cells[j] != "") {
						lineData.push(parseInt(cells[j]));
					}
				}
				if (lineData.length > 0)
					data.push(lineData);
			}
			return data;
		}
	</script>
</head>

<body>

	<h2>Çoklu Sır Paylaşım Şeması </h2>

	<h3>Sırı Oluşturma</h3>
	
	<table>
	
	<tr>
	<td> <label class="col-sm-2 control-label"><b>GF</b></label> </td>
	<td> <input type="text" id="txtDegree" value="2"/> </td> 
	</tr>
	
	<tr>
	<td> <label class="col-sm-2 control-label"><b>Kod</b></label> </td>
	<td> 
	<textarea class="form-control" id="txtGeneratorMatrix" rows="5">
1 0 1 0 1
0 1 0 1 1</textarea>
	</td>
	</tr>
	
	<tr>
	<td> <label class="col-sm-2 control-label"><b>Sır</b></label> </td>
	<td> <input type="text" id="txtSecret" value="1 0 1 1 0 1 1 0"/> </td> 
	</tr>
	
	<tr>
	<td> </td>
	<td> <input type="button" id="btnConstructSecret" value="Sırrı Oluştur" /> </td>
	</tr>
	
	</table>
	
	<div id="divConstSecretResult"></div>

	
	<hr />
	<h3>Sırrı Çözme</h3>
	
	<div id="divFindSecretParams">
		<!--<b>q:</b> <input type='text' id='txtQ2' value='2'/> <br />
		<div id="divSecretInputs"></div>-->
		<input type='button' id='btnFindSecret' value='Sırrı Bul' />
	</div>
	<div id="divFindSecretResult"></div>

	<script type="text/javascript">
		
		var factorial = function(num) {
			var result  = 1;
			for(var i = 1; i <= num; i++)
				result *= i;
			return result;
		}
		var combination = function(n,k) {
			return factorial(n) / (factorial(k) * factorial(n-k));
		}
		var combinations = function(start, end) {
			var data = [];
			for (var i = start; i <= end; i++)
				data.push(i);
			
			var target = [];
			var result = get_combinations(target, data);
			
			return result;
		}
		var get_combinations = function(target, data) {
			
			var result = [];
			for (var i = 0; i < data.length; i++) {
				
				var new_target = target.slice(0);
				var new_data = data.slice(0);
				new_target.push(data[i]);
				new_data = new_data.slice(i+1);
				result.push(new_target);
				var r = get_combinations(new_target, new_data);
				for (j = 0; j < r.length; j++)
					result.push(r[j]);
			}
			return result;
		}
		var sortbylength = function(array) {
			for (var i = 1; i < array.length; i++) {
				for (var j = 0; j < array.length-i; j++) {
					if (array[j].length > array[j+1].length) {
						var tmp = array[j];
						array[j] = array[j+1];
						array[j+1] = tmp;
					}
				}
			}
			return array;
		}
		
		
		
		$(document).ready(function () {
			$("input[type='button']").click(function (e) {
				if (e.target.id == "btnConstructSecret") {
					
					var getWord = function (k,q,i) {		
						var data = [];
						
						do {
							var r = i % q;
							i = parseInt(i / q); 
							data.push(r);
							if (i  < q)
								data.push(i);
						} while(i >= q)
						
						var dim = k - data.length;
						for (var j = 0; j < dim; j++) {
							data.push(0);
						}
						data = data.reverse();
						return new CodeWord(new Matrix(data));
					}
					
					
					var factorial = function(a) { var v = 1; for (var i=1; i <= a; i++) v = v * i; return v; }
					var combination = function(n,k) { return factorial(n) / (factorial(n-k) * factorial(k)); }

						
					var q = parseInt($("#txtDegree").val());
					
					var text = $('#txtGeneratorMatrix').val();
					var arr = ReadMatrix(text);
					var generator = new Matrix(arr);
					var code = new ErrorCorrectingCode(generator, q);
					
					var processor = new MatrixCalculator(q);
					var minWeight = code.n;
					var weights = Array(code.n+1).fill(0);
					for (var i = 0; i < code.M; i++) {
						var word = code.GetWord(i)
						var codeWord = code.CalculateCodeword(word);
						weights[codeWord.weight] += 1;
						if (codeWord.weight != 0)
							minWeight = Math.min(minWeight, codeWord.weight);
					}
					weights = weights.reverse();
					var d = minWeight;
					var t = parseInt((minWeight - 1) / 2);
					
					var text = $('#txtSecret').val();
					var arr = ReadMatrix(text);
					var secret = new CodeWord(new Matrix(arr));
					
					if (t < 1) {
						AddFormula("divConstSecretResult", "Hata", "Şemanın\\,çalışması\\,için\\,kodun\\,en\\,az\\,bir\\,hata\\,düzeltmesi\\,gerekir.");
						return;
					}
					if (new Matrix(arr).ColCount % code.k != 0) {
						AddFormula("divConstSecretResult", "Hata", "Sırrın, \\, boyutu \\, " + code.k + "\\, katı \\, olmalıdır.");
						return;
					}
					
					var secretWords = [];
					for (var i = 0; i < secret.length; i += code.k) {
						var d = [];
						for (var j = 0; j < code.k; j++) {
							d.push(secret.Get(i + j));
						}
						secretWords.push(new CodeWord(new Matrix(d)));
					}
					
					$("#divConstSecretResult").html("");
					var info = "\\begin{eqnarray*}";
					info += "q&=&" + code.q + " \\\\";
					info += "n&=&" + code.n + " \\\\";
					info += "k&=&" + code.k + " \\\\";
					info += "M&=&" + code.M + " \\\\";
					info += "d&=&" + d + " \\\\";
					info += "t&=&" + t + " \\\\";
					info += "\\end{eqnarray*}";
					AddFormula("divConstSecretResult", "MathOutputInfo", info);
					$("#divConstSecretResult").append("<br />");
					
					
					var positions = [];
					while (positions.length < t) {
						var val = parseInt(Math.random() * (code.n));
						if (positions.indexOf(val) < 0)
							positions.push(val);
					}
					var hArray = Array(code.n).fill(0);
					for (var i = 0; i < positions.length; i++)
						hArray[positions[i]] = 1;
					var h = new Matrix(hArray);
					
					
					AddFormula("divConstSecretResult", "Secret1", "G=" + generator.ToLatex(true) );
					//AddFormula("divConstSecretResult", "Secret2", "s=" + new Matrix(arr).ToLatex() );
					AddFormula("divConstSecretResult", "Secret3", "h=" + h.ToLatex() );
					$("#divConstSecretResult").append("<br />");
					
					
					
					// Ağırlık sayaçları
					var polynom = new Polynomial(weights, null, "z");
					var derrivative = new Polynomial(weights, null, "z");
					for (var i = 0; i < t; i++)
						derrivative = derrivative.Derivative(1);	
					
					AddFormula("divConstSecretResult", "WeightCounter1", "A(z)=" + polynom.Text);
					AddFormula("divConstSecretResult", "WeightCounter2", "A" + "'".repeat(t) + "(z)=" + derrivative.Text);
					AddFormula("divConstSecretResult", "WeightCounter3", "A" + "'".repeat(t) + "(1)=" + derrivative.Calculate(1));
					$("#divConstSecretResult").append("<br />");
					// Ağırlık sayaçları son
					
					
					var positions = [];
					var der = derrivative.Data.reverse();
					for (var i = 0; i < der.length; i++) {
						if (der[i] != 0)
							positions.push(i);
					}
					
					var vectors = []
					for (var i = 0; i < Math.pow(code.q, code.n); i++) {
						var word = getWord(code.n, code.q, i);
						if (word.weight <= t && word.weight > 0)
							vectors.push(word);
					}
					
					for (var j = 0; j < code.M; j++) {
						var wrd = code.GetWord(j)
						var codeWord = code.CalculateCodeword(wrd);
						//if (codeWord.weight == 0)
						//	continue;
						
						var count = 0;
						var text = "c=" + codeWord.Text + ",\\quad "
						text += "c+h=\\{";
						for (var i = 0; i < vectors.length; i++) {
							var word = vectors[i];
							var cwd = new CodeWord(processor.Add(codeWord.Data, word.Data));
							if (positions.indexOf(cwd.weight) >= 0) {
								text += cwd.Text + ",";
								count++;
							}
						}
						
						text = text.substring(0, text.length-1);
						if (count == 0)
							text += " \\varnothing ";
						else 
							text += "\\}";
						AddFormula("divConstSecretResult", "MinimalSets" + j, text);
					}
					
					
					var shares = [];
					for (var i = 0; i < code.n; i++) {
						shares.push([]);
					}
					for (var i = 0; i < secretWords.length; i++) {
					
						var encoded = processor.Add(processor.Multiply(secretWords[i].Data, generator), h);
						var encodedWord = new CodeWord(encoded);
						
						for (var j = 0; j < encoded.Data[0].length; j++) {
							share = shares[j];
							var val = encoded.Get(0, j);
							share.push(val);
						}
					}
					for (var i = 0; i < shares.length; i++) {
					
						var shareText = shares[i].reduce(function(acc, cur) { return "" + acc + " " + cur; });
						$("#divConstSecretResult").append("Share " + (i+1) + ":<b><input id='txtSharePart" + (i+1) + "' type='text'></b><br />");
						$("#txtSharePart" + (i+1)).val(shareText);
					}
					
					//var text = CreateInput(code.n, q);
					//$("#divSecretInputs").html(text);
					//$('#txtQ2').val(q);
				}
				else if (e.target.id == "btnFindSecret") {
					
					$("#divFindSecretResult").html("");
					var q = parseInt($('#txtDegree').val());
					var processor = new MatrixCalculator(q);
					
					var text = $('#txtGeneratorMatrix').val();
					var arr = ReadMatrix(text);
					var generator = new Matrix(arr);
					var code = new ErrorCorrectingCode(generator, q);
					
					var originalSecretText = $('#txtSecret').val();
					var originalSecretArray = ReadMatrix(originalSecretText);
					var original_secret = new CodeWord(new Matrix(originalSecretArray));
					
					var indices = [];
					var values = [];
					$("[id^=txtSharePart]").each(function() {
						var i = parseInt($(this).attr('num')) - 1;
						var value =  ReadMatrix($(this).val())[0];
						indices.push(i);
						values.push(value);
					});
					
					
					var syndromes = code.Syndroms();
					var syndromText = "\\begin{array}{cc} Syndrom & Coset Leader \\\\ \\hline";
					for (var prop in syndromes) {
						// skip loop if the property is from prototype
						if(!syndromes.hasOwnProperty(prop)) continue;
						syndromText += prop + "&" + syndromes[prop].Text + "\\\\";
					}
					syndromText += "\\end{array}";
					
					AddFormula("divFindSecretResult", "divMat_Result1",  syndromText);
					
					
					var decodeList = {};
					for (var i = 0; i  < code.M; i++) {
						var word = code.GetWord(i);
						var codeword = code.CalculateCodeword(word);
						decodeList[codeword.Text] = word;
					}
					
					
					var combs = combinations(1, code.n);
					combs = sortbylength(combs);
					var text = "<table>";
					text += "<tr>"
					text += "<th>Katılımcılar</th>";
					text += "<th>Sonuç</th>";
					text += "<th>Doğru Konum Sayısı</th>";
					text += "</tr>";
					var all_count = combs.length;
					var true_positive = 0;
					var false_positive = 0;
					var false_negative = 0;
					for (var i = 0; i < combs.length; i++) {
					
						var subset = "";
						var comb = combs[i];
						for (var k = 0; k < comb.length; k++) {
							subset += comb[k];
							if (k < comb.length-1)
								subset += ",";
						}
						
						var truePositions = 0;
						var secretLength = values[0].length;
						var secret = [];
						var style = "";
						for (var j = 0; j < secretLength; j++) {
							
							var array = [];
							for (var ii = 1; ii <= code.n; ii++) {
								if (comb.indexOf(ii) >= 0)
									array.push(values[ii-1][j]);
								else array.push(0);
							}
							//console.log(array);
							
							var recived = new CodeWord(new Matrix(array));
							var synd = new CodeWord(processor.Multiply(recived.Data, code.DualCode().Generator.Transpose()));
							var error = syndromes[synd.Text];
							var corrected = new CodeWord(processor.Subtract(recived.Data, error.Data));
							var decoded = decodeList[corrected.Text];
							
							for (var jj = 0; jj < decoded.length; jj++) {
								secret.push(decoded.Get(jj));
							}
							
							//secret = secret.replace(/\&/g, '&amp;');
							//secret = secret.replace(/\</g, '&lt;');
							//secret = secret.replace(/\>/g, '&gt;');
							//secret = secret.replace(/\"/g, '&quot;');
							
						}
						
						for (var iii = 0; iii < original_secret.length; iii++)
							if (originalSecretArray[0][iii] == secret[iii])
								truePositions += 1;
						
						if (truePositions == secretLength*2)
							style += "class='greenBackground'";
						
						var secretText = secret.reduce(function(acc, cur) { return "" + acc + " " + cur; });
						
						text += "<tr>";
						text += "<td " + style + ">";
						text += subset;
						text += "</td>";
						text += "<td " + style + ">";
						text += secretText;
						text += "</td>";
						text += "<td align='center' " + style + ">";
						text += truePositions;
						text += "</td>";
						text += "</tr>"
						//console.log(subset);
					
					}
					text += "</table>";
					
					$("#divFindSecretResult").append("<br />");
					$("#divFindSecretResult").append("Bütün kombinasyonların sayısı: " + all_count + "<br />");
					$("#divFindSecretResult").append("True Positive: " + true_positive + "<br />");
					$("#divFindSecretResult").append("False Positive: " + false_positive + "<br />");
					$("#divFindSecretResult").append("False Negative: " + false_negative + "<br />");
					$("#divFindSecretResult").append("<br />");
					$("#divFindSecretResult").append(text);
					
					
					

					
					return;

				}
				
			});
		});
	</script>

</body>

</html>
